#ifndef LIBWTREF_H
#define LIBWTREF_H

#include <stdio.h>
#include <wtruntime/wtruntime.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef void (*LIBWTREF_PFN_ERROR_CB)(void* priv, const char* msg,
	wt_error err);

wt_error libwtref_init(wt_profile vm, LIBWTREF_PFN_ERROR_CB errcb,
	void* errcb_priv);

wt_error libwtref_set_loader_ops(wt_profile vm, FILE* const out);

wt_bool libwtref_run_vm(wt_profile vm, struct wtr_context* const ctx,
	LIBWTREF_PFN_ERROR_CB errcb, void* errcb_priv, wt_u32* const retc,
	wt_u32 retmax, wt_value* retv);

void libwtref_handle_iocall(struct wtr_context* const ctx,
	LIBWTREF_PFN_ERROR_CB errcb, void* errcb_priv);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* LIBWTREF_H */
