//================================================================================================
// $Id: tinyframe.h 6308 2023-01-16 20:16:41Z aron $
//
// Project:
//		Welltype Compiler
// Contents:
//		Tiny frame layout helper
// Authors:
//		Aron Barath, 2015-2023
//================================================================================================
// Copyright (c) Aron Barath
//================================================================================================

#ifndef WTC_TINYFRAME_H
#define WTC_TINYFRAME_H

namespace wtc
{

class TinyFrame
{
	wt_u32 mSize;

public:
	TinyFrame() : mSize(0) { }

	wt_u32 Add(wt_u32 size)
	{
		wt_u32 offs = mSize;
		if(4>size) { size = 4; }
		mSize += size;
		return offs;
	}

	wt_u32 Size() const
	{
		return mSize;
	}
};

} // wtc

#endif // WTC_TINYFRAME_H
