#ifndef WTRUNTIME_VECTOR_H
#define WTRUNTIME_VECTOR_H

#include "config.h"
#include <stddef.h>

struct wtr_profile;

struct wtr_vector
{
	void** data;
	size_t count;
	size_t capacity;
};

#define wtr_vector_size(_vec_)   ((_vec_)->count)

/* returns zero on success */
int wtr_vector_create(struct wtr_vector* const vec,
	struct wtr_profile* const vm, const size_t capacity);

void wtr_vector_delete(struct wtr_vector* const vec,
	struct wtr_profile* const vm);

void wtr_vector_clear(struct wtr_vector* const vec);

/* returns zero on success */
int wtr_vector_push_back(struct wtr_vector* const vec,
	struct wtr_profile* const vm, void* const new_elem);

int wtr_vector_pop_back(struct wtr_vector* const vec);

void** wtr_vector_at(struct wtr_vector* const vec, const size_t index);

int wtr_vector_set(struct wtr_vector* const vec,
	const size_t index, void* elem);

int wtr_vector_shrink_to_fit(struct wtr_vector* const vec,
	struct wtr_profile* const vm);

/* returns boolean, whether the specified pointer is found or not; index */
/* return is optional */
int wtr_vector_find(struct wtr_vector* const vec, void* const elem,
	size_t* const out_index);

#endif /* WTRUNTIME_VECTOR_H */
